; Source created with Parsic Version 3.x

; at              : 12/08/02 12.37.57


; Project File    : c:\PROGRA~1\PARSIC\GIOCOLED.PIC

; Project Version : 1.0.9

; Created         : 11/08/02 20.13.00

; Last change     : 12/08/02 12.37.41

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

SYS_TMP1	= 12	; located in Bank 0, 1
S0	= 13	; located in Bank 0, 1
ZR1	= 14	; located in Bank 0, 1
ZR1_FD	= 15	; located in Bank 0, 1
SYS_WSAV	= 16	; located in Bank 0, 1
SYS_SSAV	= 17	; located in Bank 0, 1
TR1	= 18	; located in Bank 0, 1
TR1_HI	= 19	; located in Bank 0, 1
S1	= 20	; located in Bank 0, 1
TR2	= 21	; located in Bank 0, 1
TR2_HI	= 22	; located in Bank 0, 1
TR3	= 23	; located in Bank 0, 1
TR3_HI	= 24	; located in Bank 0, 1
RAM	= 25	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_1
	INCF TR2_HI,F

SYS_INT_LABEL_1
	INCFSZ TR3,F
	GOTO SYS_INT_LABEL_2
	INCF TR3_HI,F

SYS_INT_LABEL_2

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Verteiler -> BV1
;***************************************************

	BTFSC S0,0
	GOTO LABEL_BV1_0
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
	GOTO LABEL_BV1_0_END
LABEL_BV1_0
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,0
LABEL_BV1_0_END

;**********************************************

	BTFSC S0,1
	GOTO LABEL_BV1_1
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,1
	GOTO LABEL_BV1_1_END
LABEL_BV1_1
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,1
LABEL_BV1_1_END

;**********************************************

	BTFSC S0,2
	GOTO LABEL_BV1_2
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,2
	GOTO LABEL_BV1_2_END
LABEL_BV1_2
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,2
LABEL_BV1_2_END

;**********************************************

	BTFSC S0,3
	GOTO LABEL_BV1_3
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,3
	GOTO LABEL_BV1_3_END
LABEL_BV1_3
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,3
LABEL_BV1_3_END

;**********************************************

	BTFSC S0,4
	GOTO LABEL_BV1_4
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,4
	GOTO LABEL_BV1_4_END
LABEL_BV1_4
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,4
LABEL_BV1_4_END

;**********************************************

	BTFSC S0,5
	GOTO LABEL_BV1_5
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,5
	GOTO LABEL_BV1_5_END
LABEL_BV1_5
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,5
LABEL_BV1_5_END

;**********************************************

	BTFSC S0,6
	GOTO LABEL_BV1_6
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,6
	GOTO LABEL_BV1_6_END
LABEL_BV1_6
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,6
LABEL_BV1_6_END

;**********************************************

	BTFSC S0,7
	GOTO LABEL_BV1_7
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,7
	GOTO LABEL_BV1_7_END
LABEL_BV1_7
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,7
LABEL_BV1_7_END

;**********************************************


;***************************************************
; Unterprogramm LUCI aufrufen
;***************************************************

	MOVFW ZR1

	CALL LUCI

	MOVWF S0

	BSF INTCON,GIE
;***************************************************
; Zhler -> ZR1
;***************************************************

	BTFSS S1,0	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S1,7
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

LABEL_ZR1_SETFD

	BTFSS S1,7
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 232
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 232
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S1,1
	GOTO LABEL_TR1_CLR
	BSF S1,1
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S1,1
LABEL_TR1_ENDE

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 59
	SUBWF ZR1,W	; F - W -> W

LABEL_IF1_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S1,0
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S1,0

LABEL_IF1_EXIT
;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 161
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S1,3
	GOTO LABEL_TR2_CLR
	BSF S1,3
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S1,3
LABEL_TR2_ENDE

;***************************************************
; Timer -> TR3
;***************************************************

	MOVLW 3	; Test auf >=
	SUBWF TR3_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR3_CHECK
	MOVLW 209
	SUBWF TR3,W	;F-W -> W
LABEL_TR3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR3_ENDE

LABEL_TR3_RESET
	MOVLW 3	; Test auf >=
	SUBWF TR3_HI,F	;F-W -> F
	MOVLW 209
	SUBWF TR3,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR3_HI,F

LABEL_TR3_SET	; toggel output
	BTFSC S1,2
	GOTO LABEL_TR3_CLR
	BSF S1,2
	GOTO LABEL_TR3_ENDE
LABEL_TR3_CLR
	BCF S1,2
LABEL_TR3_ENDE

;***************************************************
; ODER - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSC S1,5
	GOTO LABEL_LG1_TRUE
LABEL_LG1_2
	BTFSC S1,4
	GOTO LABEL_LG1_TRUE
LABEL_LG1_3
	BTFSC S1,6
	GOTO LABEL_LG1_TRUE

LABEL_LG1_FALSE
	BCF S1,7
	GOTO LABEL_LG1_ENDE
LABEL_LG1_TRUE
	BSF S1,7
LABEL_LG1_ENDE
;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS S1,1
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S1,5
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF S1,5
LABEL_LG2_ENDE
;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S1,2
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,1
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S1,4
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF S1,4
LABEL_LG3_ENDE
;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSS S1,3
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,2
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF S1,6
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF S1,6
LABEL_LG4_ENDE
;****************************************

	GOTO MAIN

	ORG 958
;***************************************************
; Table -> LUCI
;***************************************************

LUCI

	MOVWF SYS_TMP1
	MOVLW HIGH LUCI_WERTE
	MOVWF PCLATH
	MOVFW SYS_TMP1
	BCF INTCON,GIE
	ADDWF PCL,F

LUCI_WERTE

	RETLW 0	; // INDEX 0
	RETLW 1	; // INDEX 1
	RETLW 2	; // INDEX 2
	RETLW 4	; // INDEX 3
	RETLW 8	; // INDEX 4
	RETLW 16	; // INDEX 5
	RETLW 32	; // INDEX 6
	RETLW 64	; // INDEX 7
	RETLW 128	; // INDEX 8
	RETLW 64	; // INDEX 9
	RETLW 32	; // INDEX 10
	RETLW 16	; // INDEX 11
	RETLW 8	; // INDEX 12
	RETLW 4	; // INDEX 13
	RETLW 2	; // INDEX 14
	RETLW 1	; // INDEX 15
	RETLW 3	; // INDEX 16
	RETLW 6	; // INDEX 17
	RETLW 12	; // INDEX 18
	RETLW 24	; // INDEX 19
	RETLW 48	; // INDEX 20
	RETLW 96	; // INDEX 21
	RETLW 192	; // INDEX 22
	RETLW 96	; // INDEX 23
	RETLW 48	; // INDEX 24
	RETLW 24	; // INDEX 25
	RETLW 12	; // INDEX 26
	RETLW 6	; // INDEX 27
	RETLW 3	; // INDEX 28
	RETLW 1	; // INDEX 29
	RETLW 15	; // INDEX 30
	RETLW 240	; // INDEX 31
	RETLW 15	; // INDEX 32
	RETLW 240	; // INDEX 33
	RETLW 0	; // INDEX 34
	RETLW 255	; // INDEX 35
	RETLW 0	; // INDEX 36
	RETLW 255	; // INDEX 37
	RETLW 0	; // INDEX 38
	RETLW 15	; // INDEX 39
	RETLW 0	; // INDEX 40
	RETLW 240	; // INDEX 41
	RETLW 0	; // INDEX 42
	RETLW 255	; // INDEX 43
	RETLW 0	; // INDEX 44
	RETLW 255	; // INDEX 45
	RETLW 0	; // INDEX 46
	RETLW 24	; // INDEX 47
	RETLW 36	; // INDEX 48
	RETLW 66	; // INDEX 49
	RETLW 128	; // INDEX 50
	RETLW 0	; // INDEX 51
	RETLW 128	; // INDEX 52
	RETLW 66	; // INDEX 53
	RETLW 36	; // INDEX 54
	RETLW 24	; // INDEX 55
	RETLW 0	; // INDEX 56
	RETLW 24	; // INDEX 57
	RETLW 36	; // INDEX 58
	RETLW 66	; // INDEX 59


	END

